#!/usr/bin/ruby -Ku

require './func/header.rb'

$cgi = CGI.new


# 一覧表示用
def showall()
  print <<-EOS
<html>
<head>
<title>著者一覧</title>
</head>
<body>
<center>
<h1>著者一覧</h1>
<hr />
<a href="./author.rb?mode=prevreg">著者を新規登録</a>
<hr />
  EOS

  # コネクション
  conn = Mysql::new($dbhost, $dbuser, $dbpass, $dbname)
  ary = Author.GetAuthor(conn)

  # 一覧取得失敗時
  if ary == nil
    print <<-EOS
<font color=red size=16>データ取得に失敗しました</font>
    EOS

  # 一覧取得成功時
  else
    # テーブルのヘッダ表示
    print <<-EOS
<table border=1>
<tr><td>著者名</td><td>著者の英名</td><td>各詳細画面へ</td><td>削除する</td></tr>
    EOS

    # 各要素ごとにテーブルの列を生成
    ary.each do |v|
      print <<-EOS
<tr><td><ruby><rb>#{v.jname}<rp>(<rt>#{v.kana}<rp>)</ruby></td>
<td>#{v.ename}</td>
<td><a href="./author.rb?mode=show&id=#{v.id}">詳細へ</a></td>
<td><a href="./author.rb?mode=delete&id=#{v.id}">削除する</a></td></tr>
      EOS
    end


    # テーブルのフッタ表示
    print "</table>\n"
  end

  # フッタ表示
  print <<-EOS
</center>
</body>
</html>
  EOS

  conn.close()

end


# 詳細表示用
def show()
  print <<-EOS
<html>
<head>
<title>著者詳細表示</title>
</head>
<body>
<center>
<h1>著者詳細情報</h1>
  EOS

  # コネクション
  conn = Mysql::new($dbhost, $dbuser, $dbpass, $dbname)
  ary = Author.GetAuthor(conn, $cgi['id'].to_i)

  # 詳細取得失敗時
  if ary == nil
    print <<-EOS
<font color=red size=16>データ取得に失敗しました</font>
    EOS

  # 詳細取得成功時
  else
    # テーブルのヘッダ表示
    print <<-EOS
<table border=1>
    EOS

    # 各要素ごとにテーブルの列を生成
    print <<-EOS
<tr><td>著者の和名</td><td>#{ary[0].jname}</td></tr>
<tr><td>著者のフリガナ</td><td>#{ary[0].kana}</td></tr>
<tr><td>著者の英名</td><td>#{ary[0].ename}</td></tr>
    EOS

    if ary[0].otherid != -1
      otherauth = Author.GetAuthor(conn, ary[0].otherid)
      print <<-EOS
<tr><td>著者の別名義</td>
<td><a href="./author.rb?mode=show&id=#{otherauth[0].id}">#{otherauth[0].jname}</a></td></tr>
      EOS
    else
      print "<tr><td>著者の別名義</td><td>なし</td></tr>"
    end

    # テーブルのフッタ表示
    print "</table>\n"
  end

  # フッタ表示
  print <<-EOS
</center>
<right>
<a href="./author.rb">一覧表示へ戻る</a>
</right>
</body>
</html>
  EOS

  conn.close()

end


# 登録情報入力用
def prevreg()

  # コネクション
  conn = Mysql::new($dbhost, $dbuser, $dbpass, $dbname)
  ary = Author.GetAuthor(conn)

  print <<-EOS
<html>
<head>
<title>著者登録画面</title>
</head>
<body>
<center>
<h1>著者登録画面</h1>
<hr />
<form action="./author.rb" method="post">
<input type="hidden" name="mode" value="reg">
<table>
<tr><td>著者の日本語名</td><td><input type="text" name="jname"></td></tr>
<tr><td>日本語名のふりがな（ひらがな）</td><td><input type="text" name="kana"></td></tr>
<tr><td>タグの英語名</td><td><input type="text" name="ename"></td></tr>
<tr><td>別名義</td><td><select name="otherid" size="1">
<option value='-1'>別名義なし</option>

  EOS

  ary.each do |v|
    print "<option value='#{v.id}'>#{v.jname}</option>\n"
  end

  print <<-EOS
</select></td></tr>
</table>
<div align="right">
<input type="reset" value="リセット">
<input type="submit" value="登録">
</div>
</form>
</center>
<a href="./author.rb">一覧表示へ戻る</a>
</body>
</html>
  EOS

end


# 登録用
def reg()
  print <<-EOS
<html>
<head>
<title>著者登録</title>
</head>
<body>
<center>
<h1>著者登録情報</h1>
  EOS

  # コネクション
  conn = Mysql::new($dbhost, $dbuser, $dbpass, $dbname)
  auth = Author.new(nil, $cgi['jname'], $cgi['kana'], $cgi['ename'], $cgi['otherid'].to_i)
  auth = Author.AddAuthor(conn, auth)

  # 詳細登録失敗時
  if auth == nil
    print <<-EOS
<font color=red size=16>データ登録に失敗しました</font>
    EOS

  # 詳細登録成功時
  else
    # テーブルのヘッダ表示
    print <<-EOS
<table border=1>
<tr><td>著者のID</td><td>#{auth.id}</td>
<tr><td>著者の和名</td><td>#{auth.jname}</td>
<tr><td>著者のフリガナ</td><td>#{auth.kana}</td>
<tr><td>著者の英名</td><td>#{auth.ename}</td>
    EOS

    if auth.otherid != -1
      otherauth = Author.GetAuthor(conn, auth.otherid)
      print <<-EOS
<tr><td>著者の別名義</td>
<td><a href="./author.rb?mode=show&id=#{otherauth[0].id}">#{otherauth[0].jname}</a></td></tr>
      EOS
    else
      print "<tr><td>著者の別名義</td><td>なし</td></tr>"
    end

    print <<-EOS
</table>
    EOS
  end

  # フッタ表示
  print <<-EOS
</center>
<right>
<a href="./author.rb">一覧表示へ戻る</a>
</right>
</body>
</html>
  EOS

  conn.close()

end


# 削除
def delete()
  conn = Mysql::new($dbhost, $dbuser, $dbpass, $dbname)
  QueryToComicdb(conn, "update Author_TBL set otherid = -1 where otherid = #{$cgi["id"].to_i}")
  Author.DeleteAuthor(conn, $cgi["id"].to_i)
  conn.close()
end


# mainはここから

print "Content-type: text/html\n\n"


if $cgi['mode'] == "showall"
  showall()
elsif $cgi['mode'] == "show"
  show()
elsif $cgi['mode'] == "reg"
  reg()
elsif $cgi['mode'] == "prevreg"
  prevreg()
elsif $cgi['mode'] == "delete"
  delete()
  showall()
else
  showall()
end
