var cvsw, cvsh;
var page_index, page_max;
var menu_height;
var mousex, mousey;
var is_mousedown;
var redrawflag;
var ga_canvas;
var images;
var precount = 5;
var datapath = "./data/";
var view_mode;
var expand_mode;
var viewed_count;
var balflag;


// 定数一覧
var KEY = { RIGHT:39, UP:38, LEFT:37, DOWN:40 };

var VM_SINGLE = 0;
var VM_DOUBLE = 1;

var PM_PREV = 0;
var PM_NEXT = 1;

var EM_NONE = 0;
var EM_EXPAND = 1;



onload = function()
{
	var i;
	
	ga_canvas = {
		0: document.getElementById("viewer1"),
		1: document.getElementById("viewer2")
	};
	page_index = 1;
	page_max = 204;
	menu_height = 30;
	mousex = 0;
	mousey = 0;
	viewed_count = 0;
	view_mode = VM_SINGLE;
	expand_mode = EM_NONE;
	is_mousedown = false;
	balflag = false;
	redrawflag = true;
	images = new Array();
	for (i = 0; i < precount; i++) {
		images[i] = new Image();
		images[i].onload = function() {
			redrawflag = true;
		};
	}
	pre_load();
	
	ga_canvas[1].style.visibility =  "hidden";
	ga_canvas[0].style.visibility = "visible";
	
	redrawflag = true;
	setInterval("draw_viewer()", 50);
};

onresize = function()
{
	redrawflag = true;
};

onmousedown = function(e)
{
	if (e.button == 0)
	{
		is_mousedown = true;
	}
};

onmouseup = function(e)
{
	if (e.button == 0)
	{
		is_mousedown = false;
	}
};

onmousemove = function(e)
{
	var mx, my;
	var rect = e.target.getBoundingClientRect();
	
	mousex = e.clientX - rect.left;
	mousey = e.clientY - rect.top;
	
	mx = cvsw / 2 - 265;
	my = cvsh - menu_height;
	
	// カーソルが拡大鏡の上か？
	if (!(mousex < mx+1 || mx+29 < mousex || mousey < my)) {
		redrawflag = true;
		ga_canvas[0].style.cursor = "pointer";
	}
	// カーソルが末尾ベージボタンの上か？
	else if (!(mousex < mx+31 || mx+59 < mousex || mousey < my)) {
		redrawflag = true;
		ga_canvas[0].style.cursor = "pointer";
	}
	// カーソルが次ベージボタンの上か？
	else if (!(mousex < mx+61 || mx+89 < mousex || mousey < my)) {
		redrawflag = true;
		ga_canvas[0].style.cursor = "pointer";
	}
	// カーソルが前ベージボタンの上か？
	else if (!(mousex < mx+291 || mx+319 < mousex || mousey < my)) {
		redrawflag = true;
		ga_canvas[0].style.cursor = "pointer";
	}
	// カーソルが先頭ベージボタンの上か？
	else if (!(mousex < mx+321 || mx+349 < mousex || mousey < my)) {
		redrawflag = true;
		ga_canvas[0].style.cursor = "pointer";
	}
	// カーソルが表示モード切り替えボタンの上か？
	else if (!(mousex < mx+501 || mx+529 < mousex || mousey < my)) {
		redrawflag = true;
		ga_canvas[0].style.cursor = "pointer";
	}
	// スクロール上か？
	else if (!(mousex < mx+102 || mx+278 < mousex || mousey < my)) {
		redrawflag = true;
		ga_canvas[0].style.cursor = "pointer";
	}
	// それ以外
	else {
		ga_canvas[0].style.cursor = "default";
		
		// 前回ヒントを描画し今回はヒント表示域から抜けだした場合、一度だけ再描画する
		if (balflag == true) {
			redrawflag = true;
		}
	}
};

onclick = function(e)
{
	var mx, my;
	var rect = e.target.getBoundingClientRect();
	
	mousex = e.clientX - rect.left;
	mousey = e.clientY - rect.top;
	
	mx = cvsw / 2 - 265;
	my = cvsh - menu_height;
	
	// カーソルが拡大鏡の上か？
	if (!(mousex < mx+1 || mx+29 < mousex || mousey < my)) {
		// EM_NONEならEM_EXPANDへ。EM_EXPANDならEM_NONEへ
		expand_mode = 1 - expand_mode;
		redrawflag = true;
	}
	// カーソルが末尾ベージボタンの上か？
	else if (!(mousex < mx+31 || mx+59 < mousex || mousey < my)) {
		page_index = page_max;
		pre_load();
	}
	// カーソルが次ベージボタンの上か？
	else if (!(mousex < mx+61 || mx+89 < mousex || mousey < my)) {
		if (page_index < page_max) {
			page_index ++;
			pre_load();
		}
	}
	// カーソルが前ベージボタンの上か？
	else if (!(mousex < mx+291 || mx+319 < mousex || mousey < my)) {
		if (1 < page_index) {
			page_index --;
			pre_load();
		}
	}
	// カーソルが先頭ベージボタンの上か？
	else if (!(mousex < mx+321 || mx+349 < mousex || mousey < my)) {
		page_index = 1;
		pre_load();
	}
	// カーソルが表示モード切り替えボタンの上か？
	else if (!(mousex < mx+501 || mx+529 < mousex || mousey < my)) {
		// VM_SINGLEならVM_DOUBLEへ。VM_DOUBLEならVM_SINGLEへ
		view_mode = 1 - view_mode;
		redrawflag = true;
	}
	// スクロール上か？
	else if (!(mousex < mx+102 || mx+278 < mousex || mousey < my)) {
		pindex = Math.floor((mx + 278 - mousex) * page_max / 176);
		if (1 <= pindex && pindex <= page_max) {
			page_index = pindex;
			pre_load();
		}
	}
	// 左半分がクリックされたら次へ
	else if (mousex < cvsw/2) {
		if ((page_index + viewed_count) <= page_max) {
			page_index += viewed_count;
			pre_load();
		}
	}
	// 右半分がクリックされたら前へ
	else if (mousex >= cvsw/2) {
		if (1 <= (page_index - viewed_count)) {
			page_index -= viewed_count;
			pre_load();
		}
	}
		
};

onmousewheel = function(e) {
	pagemove(e.wheelDelta < 0 ? PM_NEXT : PM_PREV);
};

if(window.addEventListener) {
	window.addEventListener('DOMMouseScroll', function(e) {
		pagemove(e.detail > 0 ? PM_NEXT : PM_PREV);
	}, false);
}

onkeydown = function(e) {
	switch(e.keyCode) {
		case KEY.RIGHT:
			if (1 < page_index) {
				page_index --;
				pre_load();
			}
			redrawflag = true;
			break;
		case KEY.UP:
			if (1 <= (page_index - viewed_count)) {
				page_index -= viewed_count;
				pre_load();
			}
			redrawflag = true;
			break;
		case KEY.LEFT:
			if (page_index < page_max) {
				page_index ++;
				pre_load();
			}
			redrawflag = true;
			break;
		case KEY.DOWN:
			if ((page_index + viewed_count) <= page_max) {
				page_index += viewed_count;
				pre_load();
			}
			redrawflag = true;
			break;
	}
};

ontouchstart = function(e)
{
	mousex = e.touches[0].pageX;
	mousey = e.touches[0].pageY;
	is_mousedown = true;
};

ontouchmove = function(e)
{
	mousex = e.touches[0].pageX;
	mousey = e.touches[0].pageY;
	
	redrawflag = true;
}


ontouchend = function(e)
{
	var mx, my;
	
	mx = cvsw / 2 - 265;
	my = cvsh - menu_height;
	
	// カーソルが拡大鏡の上か？
	if (!(mousex < mx+1 || mx+29 < mousex || mousey < my)) {
		// EM_NONEならEM_EXPANDへ。EM_EXPANDならEM_NONEへ
		expand_mode = 1 - expand_mode;
		redrawflag = true;
	}
	// カーソルが末尾ベージボタンの上か？
	else if (!(mousex < mx+31 || mx+59 < mousex || mousey < my)) {
		page_index = page_max;
		pre_load();
	}
	// カーソルが次ベージボタンの上か？
	else if (!(mousex < mx+61 || mx+89 < mousex || mousey < my)) {
		if (page_index < page_max) {
			page_index ++;
			pre_load();
		}
	}
	// カーソルが前ベージボタンの上か？
	else if (!(mousex < mx+291 || mx+319 < mousex || mousey < my)) {
		if (1 < page_index) {
			page_index --;
			pre_load();
		}
	}
	// カーソルが先頭ベージボタンの上か？
	else if (!(mousex < mx+321 || mx+349 < mousex || mousey < my)) {
		page_index = 1;
		pre_load();
	}
	// カーソルが表示モード切り替えボタンの上か？
	else if (!(mousex < mx+501 || mx+529 < mousex || mousey < my)) {
		// VM_SINGLEならVM_DOUBLEへ。VM_DOUBLEならVM_SINGLEへ
		view_mode = 1 - view_mode;
		redrawflag = true;
	}
	// スクロール上か？
	else if (!(mousex < mx+102 || mx+278 < mousex || mousey < my)) {
		pindex = Math.floor((mx + 278 - mousex) * page_max / 176);
		if (1 <= pindex && pindex <= page_max) {
			page_index = pindex;
			pre_load();
		}
	}
	// 左半分がクリックされたら次へ
	else if (mousex < cvsw/2) {
		if ((page_index + viewed_count) <= page_max) {
			page_index += viewed_count;
			pre_load();
		}
	}
	// 右半分がクリックされたら前へ
	else if (mousex >= cvsw/2) {
		if (1 <= (page_index - viewed_count)) {
			page_index -= viewed_count;
			pre_load();
		}
	}
	
	is_mousedown = false;
};


function pagemove(step) {
	if (step == PM_PREV) {
		if (1 <= (page_index - viewed_count)) {
			page_index -= viewed_count;
			pre_load();
			redrawflag = true;
		}
	}
	else {
		if ((page_index + viewed_count) <= page_max) {
			page_index += viewed_count;
			pre_load();
			redrawflag = true;
		}
	}
};


function pre_load()
{
	var i, bufpos;
	var padstr;
	
	for (i = page_index; i < page_index + precount; i++) {
		if (page_index <= page_max) {
			bufpos = i % precount;
			padstr = "0000" + String(i);
			padstr = padstr.substr(padstr.length - 5, 5);
			if (images[bufpos].src.substr(images[bufpos].src.length - 5, 5) != padstr) {
				images[bufpos].src = datapath + padstr + ".jpg?" + padstr;
			}
		}
	}
};


function draw_viewer()
{
	var backimg;
	
	if (redrawflag == true) {
		// 画面サイズにCanvasサイズをフィットさせる
		ga_canvas[0].width = window.innerWidth;
		ga_canvas[1].width = window.innerWidth;
		ga_canvas[0].height = window.innerHeight;
		ga_canvas[1].height = window.innerHeight;
		
		// グローバル変数に幅と高さ格納
		cvsw = ga_canvas[0].width;
		cvsh = ga_canvas[0].height;
		
		var ctx = ga_canvas[1].getContext('2d');
		
		ctx.fillStyle = "black";
		ctx.fillRect(0, 0, ga_canvas[0].width, ga_canvas[0].height);
		
		draw_image(ctx);
		draw_control(ctx);
		draw_balloon(ctx);
		
		backimg = ctx.getImageData(0, 0, cvsw, cvsh);
		ctx = ga_canvas[0].getContext('2d');
		ctx.putImageData(backimg, 0, 0);
		
		redrawflag = false;
	}
};

function draw_image(ctx)
{
	var dw, dh, dw1, dh1;
	var bufpos, bufpos1;
	
	bufpos = page_index % precount;
	bufpos1 = (page_index+1) % precount;
	
	// 画像ロードが完了している時(VM_SINGLE)
	if (images[bufpos].complete == true && view_mode == VM_SINGLE) {
		dw = Math.floor((cvsh-30) * images[bufpos].width / images[bufpos].height);
		
		// 横幅が収まった場合
		if (dw <= cvsw) {
			ctx.drawImage(images[bufpos], (cvsw - dw)/2, 0, dw, cvsh - 30);
		}
		// 横幅が収まらなかった場合、縦幅を調整
		else {
			dh = Math.floor(cvsw * images[bufpos].height / images[bufpos].width);
			ctx.drawImage(images[bufpos], 0, (cvsh - dh - 30)/2, cvsw, dh);
		}
		viewed_count = 1;
	}
	// 画像ロードが完了している時(VM_DOUBLEで最後のページ)
	else if (images[bufpos].complete == true && view_mode == VM_DOUBLE && page_index == page_max) {
		dw = Math.floor((cvsh-30) * images[bufpos].width / images[bufpos].height);
		
		// 横幅が収まった場合
		if (dw <= cvsw) {
			ctx.drawImage(images[bufpos], (cvsw - dw)/2, 0, dw, cvsh - 30);
		}
		// 横幅が収まらなかった場合、縦幅を調整
		else {
			dh = Math.floor(cvsw * images[bufpos].height / images[bufpos].width);
			ctx.drawImage(images[bufpos], 0, (cvsh - dh - 30)/2, cvsw, dh);
		}
		viewed_count = 1;
	}
	// 画像ロードが完了している時(VM_DOUBLE)
	else if (images[bufpos].complete == true && images[bufpos1].complete == true && view_mode == VM_DOUBLE) {
		dw = Math.floor((cvsh-30) * images[bufpos].width / images[bufpos].height);
		dw1 = Math.floor((cvsh-30) * images[bufpos1].width / images[bufpos1].height);
		
		// 横が広いページ（見開きで同じページ）の場合、VM_SINGLEで表示
		if (images[bufpos].width >= images[bufpos].height || images[bufpos1].width >= images[bufpos1].height) {
			// 横幅が収まった場合
			if (dw <= cvsw) {
				ctx.drawImage(images[bufpos], (cvsw - dw)/2, 0, dw, cvsh - 30);
			}
			// 横幅が収まらなかった場合、縦幅を調整
			else {
				dh = Math.floor(cvsw * images[bufpos].height / images[bufpos].width);
				ctx.drawImage(images[bufpos], 0, (cvsh - dh - 30)/2, cvsw, dh);
			}
			viewed_count = 1;
		}
		// 横幅の合計が画面幅を超えたらVM_SINGLE表示
		else if (dw + dw1 > cvsw) {
			// 横幅が収まった場合
			if (dw <= cvsw) {
				ctx.drawImage(images[bufpos], (cvsw - dw)/2, 0, dw, cvsh - 30);
			}
			// 横幅が収まらなかった場合、縦幅を調整
			else {
				dh = Math.floor(cvsw * images[bufpos].height / images[bufpos].width);
				ctx.drawImage(images[bufpos], 0, (cvsh - dh - 30)/2, cvsw, dh);
			}
			viewed_count = 1;
		}
		// 横が狭いページの場合、VM_DOUBLEで表示
		else {
			// 右側画像について
			ctx.drawImage(images[bufpos], (cvsw-dw+dw1)/2, 0, dw, cvsh - 30);
			// 左側画像について
			ctx.drawImage(images[bufpos1], (cvsw-dw-dw1)/2, 0, dw1, cvsh - 30);
			viewed_count = 2;
		}
	}
	// 画像ロード中の時
	else {
		ctx.strokeStyle = "white";
		ctx.lineWidth = 5;
		ctx.strokeRect((cvsw - 300) / 2, 100, 300, 50);
		ctx.fillStyle = "white";
		ctx.font = "normal 32px 'sans-serif'"; 
		ctx.textAlign = "center"
		ctx.textBaseline = "middle"
		ctx.fillText("Now Loading...", cvsw/2, 125);
	}
}


function draw_balloon(ctx)
{
	var mx, my, balmsg;
	
	mx = cvsw / 2 - 265;
	my = cvsh - menu_height;
	balflag = false
	
	// カーソルが拡大鏡の上か？
	if (!(mousex < mx+1 || mx+29 < mousex || mousey < my)) {
		balmsg = "拡大";
		balflag = true;
	}
	// カーソルが末尾ベージボタンの上か？
	else if (!(mousex < mx+31 || mx+59 < mousex || mousey < my)) {
		balmsg = "最後へ";
		balflag = true;
	}
	// カーソルが次ベージボタンの上か？
	else if (!(mousex < mx+61 || mx+89 < mousex || mousey < my)) {
		balmsg = "次へ";
		balflag = true;
	}
	// カーソルが前ベージボタンの上か？
	else if (!(mousex < mx+291 || mx+319 < mousex || mousey < my)) {
		balmsg = "前へ";
		balflag = true;
	}
	// カーソルが先頭ベージボタンの上か？
	else if (!(mousex < mx+321 || mx+349 < mousex || mousey < my)) {
		balmsg = "最初へ";
		balflag = true;
	}
	// スクロール上か？
	else if (!(mousex < mx+102 || mx+278 < mousex || mousey < my)) {
		// 座標からページ番号を取得
		pindex = Math.floor((mx + 278 - mousex) * page_max / 176);
		balmsg = String(pindex);
		balflag = true;
	}
	// 表示モード切り替えボタン上か？
	else if (!(mousex < mx+502 || mx+528 < mousex || mousey < my)) {
		// 座標からページ番号を取得
		if (view_mode == VM_SINGLE) {
			balmsg = "単一表示";
		}
		else {
			balmsg = "見開き";
		}
		balflag = true;
	}
	
	// バルーンを表示させる処理
	if (balflag == true) {
		ctx.fillStyle = "white";
		ctx.strokeStyle = "gray";
		ctx.lineWidth = 2;
		
		// バルーンの外枠
		ctx.beginPath();
		ctx.moveTo(mousex - 30, my - 25);
		ctx.quadraticCurveTo(mousex - 30, my - 30, mousex - 25, my - 30);
		ctx.lineTo(mousex + 25, my - 30);
		ctx.quadraticCurveTo(mousex + 30, my - 30, mousex + 30, my - 25);
		ctx.lineTo(mousex + 30, my - 15);
		ctx.quadraticCurveTo(mousex + 30, my - 10, mousex + 25, my - 10);
		ctx.lineTo(mousex + 3, my - 10);
		ctx.lineTo(mousex, my - 2);
		ctx.lineTo(mousex - 3, my - 10);
		ctx.lineTo(mousex - 25, my - 10);
		ctx.quadraticCurveTo(mousex - 30, my - 10, mousex - 30, my - 15);
		ctx.lineTo(mousex - 30, my - 25);
		ctx.fill();
		ctx.stroke();
		
		// バルーンの中の文字列表示
		ctx.fillStyle = "black";
		ctx.font = "normal 14px 'sans-serif'"; 
		ctx.textAlign = "center"
		ctx.textBaseline = "middle"
		ctx.fillText(balmsg, mousex, my-20);
	}
}


function draw_control(ctx)
{
// - 30 拡大
// - 60 末尾
// - 90 次へ
// - 290 スクロール
// - 320 前へ
// - 350 先頭
// - 500(420, 430, 500) ページ情報

	var mx, my;
	var grad;
	
	mx = cvsw / 2 - 265;
	my = cvsh - menu_height;
	
	grad  = ctx.createLinearGradient(mx, my, mx, cvsh);
	grad.addColorStop(0, "rgb(192, 192, 192)");
	grad.addColorStop(1, "rgb(  0,   0,   0)");
	
	// メニューバーの背景を描画
	ctx.fillStyle = "black"
	ctx.fillRect(0, my, cvsw, menu_height);
	ctx.fillStyle = "rgb(20, 20, 20)";
	ctx.fillRect(0, my, cvsw, 3);
	
	// 拡大ボタン
	ctx.fillStyle = grad
	ctx.fillRect(mx+1, my, 28, menu_height);
	if (expand_mode == EM_NONE) {
		ctx.strokeStyle = "white";
	}
	else {
		ctx.strokeStyle = "red";
	}
	ctx.lineWidth = 2;
	ctx.beginPath();
	ctx.arc(mx+12, my+12, 9, 0, Math.PI*2, false);
	ctx.stroke();
	ctx.lineWidth = 2;
	ctx.beginPath();
	ctx.moveTo(mx+12, my+7);
	ctx.lineTo(mx+12, my+17);
	ctx.stroke();
	ctx.beginPath();
	ctx.moveTo(mx+7, my+12);
	ctx.lineTo(mx+17, my+12);
	ctx.stroke();
	ctx.lineWidth = 3;
	ctx.beginPath();
	ctx.moveTo(mx+18, my+18);
	ctx.lineTo(mx+25, my+25);
	ctx.stroke();
	
	// 末尾ページボタン
	ctx.fillStyle = grad
	ctx.fillRect(mx+31, my, 28, menu_height);
	ctx.strokeStyle = "white";
	ctx.lineWidth = 4;
	ctx.beginPath();
	ctx.moveTo(mx+37, my+5);
	ctx.lineTo(mx+37, my+25);
	ctx.stroke();
	ctx.fillStyle = "white";
	ctx.beginPath();
	ctx.moveTo(mx+53, my+5);
	ctx.lineTo(mx+53, my+25);
	ctx.lineTo(mx+37, my+15);
	ctx.fill();
	
	// 次ページボタン
	ctx.fillStyle = grad
	ctx.fillRect(mx+61, my, 28, menu_height);
	ctx.lineWidth = 4;
	ctx.fillStyle = "white";
	ctx.beginPath();
	ctx.moveTo(mx+83, my+5);
	ctx.lineTo(mx+83, my+25);
	ctx.lineTo(mx+67, my+15);
	ctx.fill();
	
	// スクロール
	ctx.fillStyle = grad
	ctx.fillRect(mx+91, my, 198, menu_height);
	ctx.lineWidth = 3;
	ctx.fillStyle = "white";
	ctx.fillRect(mx+102, my+12, 176, 6);
	// 位置計算
	if (is_mousedown == true) {
		scpos = mousex;
	}
	else {
		scpos = mx + 101 + ((page_max - page_index) * 172 / page_max);
	}
	ctx.fillStyle = "gray";
	ctx.fillRect(scpos, my+7, 6, 16);
	ctx.fillStyle = "white";
	ctx.fillRect(scpos+1, my+8, 4, 14);
	
	// 前ページボタン
	ctx.fillStyle = grad
	ctx.fillRect(mx+291, my, 28, menu_height);
	ctx.lineWidth = 4;
	ctx.fillStyle = "white";
	ctx.beginPath();
	ctx.moveTo(mx+297, my+5);
	ctx.lineTo(mx+297, my+25);
	ctx.lineTo(mx+313, my+15);
	ctx.fill();
	
	// 先頭ページボタン
	ctx.fillStyle = grad
	ctx.fillRect(mx+321, my, 28, menu_height);
	ctx.strokeStyle = "white";
	ctx.lineWidth = 4;
	ctx.beginPath();
	ctx.moveTo(mx+343, my+5);
	ctx.lineTo(mx+343, my+25);
	ctx.stroke();
	ctx.fillStyle = "white";
	ctx.beginPath();
	ctx.moveTo(mx+327, my+5);
	ctx.lineTo(mx+327, my+25);
	ctx.lineTo(mx+343, my+15);
	ctx.fill();
	
	// ページ情報
	ctx.fillStyle = grad;
	ctx.fillRect(mx+351, my, 148, menu_height);
	ctx.fillStyle = "black";
	ctx.fillRect(mx+355, my+5, 140, menu_height-10);
	ctx.fillStyle = "white";
	ctx.font = "normal 16px 'sans-serif'"; 
	ctx.textAlign = "right"
	ctx.textBaseline = "middle"
	ctx.fillText(String(page_index), mx+420, my+15);
	ctx.fillText("/", mx+430, my+15);
	ctx.fillText(String(page_max), mx+490, my+15);
	
	// 表示モード切り替えボタン
	ctx.fillStyle = grad
	ctx.fillRect(mx+501, my, 28, menu_height);
	ctx.lineWidth = 2;
	ctx.fillStyle = "white";
	if (view_mode == VM_SINGLE) {
		ctx.strokeRect(mx+510, my+7, 10, 16);
	}
	else {
		ctx.strokeRect(mx+505, my+7, 10, 16);
		ctx.strokeRect(mx+515, my+7, 10, 16);
	}
	
};
























