#!/usr/bin/ruby -Ku

class Author
  attr_accessor :id, :jname, :kana, :ename, :otherid
  def initialize(id, jname, kana, ename, otherid = -1)
    @id = id
    @jname = jname
    @kana = kana
    @ename = ename
    @otherid = otherid
  end
  def to_s
    return "ID:#{@id} JNAME:#{@jname} KANA:#{@kana} ENAME:#{@ename} OTHERID:#{@otherid}"
  end

  class << self
    def create_empty
      return Author.new(-1, '', '', '')
    end

    # add Author Data into DataBase
    def AddAuthor(conn, author)
      # argument check
      if conn.nil? || author.nil?
        return nil
      end
      
      otherid = (author.otherid == -1 ?  'null' : author.otherid)
      
      sql = 'insert into Author_TBL (jname, kana, ename, otherid)'
      sql += " values ('#{author.jname}', '#{author.kana}', '#{author.ename}', #{otherid})"
      
      begin
        conn.query(sql)
        author.id = conn.insert_id()
      rescue
        return nil
      end
      
      return author
    end
    
    # get all Author Data from DataBase
    def GetAuthor(conn, id = nil)
      ary = Array.new
      
      sql = 'select * from Author_TBL'
      unless id.nil?
        sql += " where id = #{id}"
      end
      sql += ' order by kana'
      
      begin
        rows = conn.query(sql)
        rows.each_hash do |row|
          tmp = Author.new(row['id'].to_i, row['jname'].to_s, row['kana'].to_s,
                           row['ename'].to_s, row['otherid'].to_i)
          ary.push(tmp)
        end
      rescue
        return nil
      end
      return ary
    end
    
    def DeleteAuthor(conn, id)
      if conn.nil? || id.nil?
        return nil
      end
      
      sql = "delete from Author_TBL where id = #{id}"
      
      begin
        conn.query(sql)
        
      rescue
        return nil
        
      end
      
      return id
    end

    alias :delete :DeleteAuthor
    alias :add :AddAuthor
    alias :get :GetAuthor
  end # class << self
end # class Author


