#!/usr/bin/ruby -Ku

require 'rubygems'
require 'RMagick'

img = Magick::ImageList.new("mikan4.jpg")
img.write("orig.jpg")


img = Magick::ImageList.new("orig.jpg")
img_flop= img.flop
img_flip= img.flip
img_flop.write("flop.jpg")
img_flip.write("flip.jpg")

img_append = Magick::ImageList.new("orig.jpg","flop.jpg")
img_append = img_append.append(false)
img_append.write("append.jpg")
img_string = Magick::ImageList.new("orig.jpg")

md = Magick::Draw.new
md.annotate(img_string, 0, 0, 0, 0, "hogehoge") do
  
  md.gravity = Magick::NorthGravity
  md.pointsize = 30
  md.fill = "blue" 
  md.stroke = "yellow"
end
img_string.write("string.jpg")


img = Magick::ImageList.new("orig.jpg")
img_string=img_string.wave(amplitude=10.0, wavelength=100.0)
img_string.write("wave.jpg")


img = Magick::ImageList.new("orig.jpg")

motion_blur=img.blur_image(radius=10.0, sigma=10.0)

motion_blur.write("blur.jpg")


img = Magick::ImageList.new("orig.jpg")
rotate=img.rotate(90)
rotate.write("rotate.jpg")

img = Magick::ImageList.new("orig.jpg")
swirl=img.swirl(360)
swirl.write('swirl.jpg')

img = Magick::ImageList.new("orig.jpg")

animation = Magick::ImageList.new
animation << img.first.copy
30.step(360,45) { |degrees| animation << img.swirl(degrees) }

animation.delay = 20
animation.iterations = 10000

animation.write('swirl.gif')
