#!/usr/bin/ruby -Ku
# -*- coding: utf-8 -*-

require './func/header.rb'

$cgi = CGI.new


# 一覧表示用
def showall()
  print <<-EOS
<html>
<head>
<LINK REL="stylesheet" HREF="css/test3.css" TYPE="text/css">
<title>タグ一覧</title>
</head>
<body>
<center>
<h1>タグ一覧</h1>
<hr />
<a href="./tag.rb?mode=prevreg">タグを新規登録</a>
<hr />
  EOS

  # コネクション
  conn = Mysql::new($dbhost, $dbuser, $dbpass, $dbname)
  ary = Tag.GetTag(conn)

  # 一覧取得失敗時
  if ary == nil
    print <<-EOS
<font color=red size=16>データ取得に失敗しました</font>
    EOS

  # 一覧取得成功時
  else
print '<h2 class ="aaaa">'
    # テーブルのヘッダ表示
    print <<-EOS
<table border=1>
<tr><td>タグ名</td><td>タグの英名</td><td>各詳細画面へ</td><td>削除</td></tr>
    EOS

    # 各要素ごとにテーブルの列を生成
    ary.each do |v|
      print <<-EOS
<tr><td>#{v.jname}</td><td>#{v.ename}</td>
<td><a href="./tag.rb?mode=show&id=#{v.id}">詳細へ</a></td>
<td><a href="./tag.rb?mode=delete&id=#{v.id}">削除する</a></td></tr>
      EOS
    end
print '</h2>'


    # テーブルのフッタ表示
    print "</table>\n"
  end

  # フッタ表示
  print <<-EOS
</center>
</body>
</html>
  EOS

  conn.close()

end


# 詳細表示用
def show()
  print <<-EOS
<html>
<head>
<title>タグ詳細表示</title>
</head>
<body>
<center>
<h1>タグ情報</h1>
  EOS

  # コネクション
  conn = Mysql::new($dbhost, $dbuser, $dbpass, $dbname)
  ary = Tag.GetTag(conn, $cgi['id'].to_i)

  # 詳細取得失敗時
  if ary == nil
    print <<-EOS
<font color=red size=16>データ取得に失敗しました</font>
    EOS

  # 詳細取得成功時
  else
    # テーブルのヘッダ表示
    print <<-EOS
<table border=1>
    EOS

    # 各要素ごとにテーブルの列を生成
    print <<-EOS
<tr><td>タグの和名</td><td>#{ary[0].jname}</td>
<tr><td>タグのフリガナ</td><td>#{ary[0].kana}</td>
<tr><td>タグの英名</td><td>#{ary[0].ename}</td>
    EOS


    # テーブルのフッタ表示
    print "</table>\n"
  end

  # フッタ表示
  print <<-EOS
</center>
<right>
<a href="./tag.rb">一覧表示へ戻る</a>
</right>
</body>
</html>
  EOS

  conn.close()

end


# 登録情報入力用
def prevreg()
  print <<-EOS
<html>
<head>
<title>タグ登録画面</title>
</head>
<body>
<center>
<h1>タグ登録画面</h1>
<hr />
<form action="./tag.rb" method="post">
<input type="hidden" name="mode" value="reg">
<table>
<tr><td>タグの日本語名</td><td><input type="text" name="jname"></td></tr>
<tr><td>日本語名のふりがな（ひらがな）</td><td><input type="text" name="kana"></td></tr>
<tr><td>タグの英語名</td><td><input type="text" name="ename"></td></tr>
</table>
<div align="right">
<input type="reset" value="リセット">
<input type="submit" value="登録">
</div>
</form>
</center>
<a href="./tag.rb">一覧表示へ戻る</a>
</body>
</html>
  EOS

end


# 登録用
def reg()
  print <<-EOS
<html>
<head>
<title>タグ登録</title>
</head>
<body>
<center>
<h1>タグ登録情報</h1>
  EOS

  # コネクション
  conn = Mysql::new($dbhost, $dbuser, $dbpass, $dbname)
  tag = Tag.new(nil, $cgi['jname'], $cgi['kana'], $cgi['ename'])
  tag = Tag.AddTag(conn, tag)

  # 詳細登録失敗時
  if tag == nil
    print <<-EOS
<font color=red size=16>データ登録に失敗しました</font>
    EOS

  # 詳細登録成功時
  else
    # テーブルのヘッダ表示
    print <<-EOS
<table border=1>
<tr><td>タグのID</td><td>#{tag.id}</td>
<tr><td>タグの和名</td><td>#{tag.jname}</td>
<tr><td>タグのフリガナ</td><td>#{tag.kana}</td>
<tr><td>タグの英名</td><td>#{tag.ename}</td>
</table>
    EOS
  end

  # フッタ表示
  print <<-EOS
</center>
<right>
<a href="./tag.rb">一覧表示へ戻る</a>
</right>
</body>
</html>
  EOS

  conn.close()

end


# 削除
def delete()
  conn = Mysql::new($dbhost, $dbuser, $dbpass, $dbname)
  Tag.DeleteTag(conn, $cgi["id"].to_i)
  conn.close()
end


# mainはここから

print "Content-type: text/html\n\n"


if $cgi['mode'] == "showall"
  showall()
elsif $cgi['mode'] == "show"
  show()
elsif $cgi['mode'] == "reg"
  reg()
elsif $cgi['mode'] == "prevreg"
  prevreg()
elsif $cgi['mode'] == "delete"
  delete()
  showall()
else
  showall()
end
